"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AdminAuthGuard = void 0;
const common_1 = require("@nestjs/common");
const user_1 = require("../user");
const core_1 = require("@nestjs/core");
const global_var_1 = require("../global.var");
let AdminAuthGuard = class AdminAuthGuard {
    constructor(moduleRef, reflector) {
        this.moduleRef = moduleRef;
        this.reflector = reflector;
    }
    onModuleInit() {
        return __awaiter(this, void 0, void 0, function* () {
            this.adminUserService = yield this.moduleRef.get(user_1.AdminUserService);
        });
    }
    canActivate(context) {
        return __awaiter(this, void 0, void 0, function* () {
            const req = context.switchToHttp().getRequest();
            const isPublic = this.reflector.get('public', context.getHandler());
            if (isPublic) {
                return true;
            }
            const auth_token = req.headers[global_var_1.ADMIN_GLOBAL.header_token || 'auth-token'];
            if (auth_token == undefined) {
                return false;
            }
            try {
                const auth_data = yield this.adminUserService.verifyAuthToken(auth_token);
                if (auth_data == undefined || !auth_data) {
                    return false;
                }
                const user = (yield this.adminUserService.isExistUser(auth_data.id));
                console.log(user);
                req.user = user;
            }
            catch (err) {
                return false;
            }
            return true;
        });
    }
};
AdminAuthGuard = __decorate([
    (0, common_1.Injectable)(),
    __metadata("design:paramtypes", [core_1.ModuleRef, core_1.Reflector])
], AdminAuthGuard);
exports.AdminAuthGuard = AdminAuthGuard;
