"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PublicDecorator = exports.AuthPermissionGuard = exports.AuthGuard = void 0;
const common_1 = require("@nestjs/common");
const guards_1 = require("./guards");
const permission_guard_1 = require("./permission_guard");
const piblic_guard_1 = require("./piblic_guard");
const AuthGuard = () => {
    return (0, common_1.applyDecorators)((0, common_1.UseGuards)(guards_1.AdminAuthGuard));
};
exports.AuthGuard = AuthGuard;
const AuthPermissionGuard = () => {
    return (0, common_1.applyDecorators)((0, common_1.UseGuards)(guards_1.AdminAuthGuard, permission_guard_1.AdminPermissionGuard));
};
exports.AuthPermissionGuard = AuthPermissionGuard;
const PublicDecorator = (flag = true) => {
    return (0, common_1.applyDecorators)((0, common_1.SetMetadata)('public', flag));
};
exports.PublicDecorator = PublicDecorator;
exports.default = {
    AdminAuthGuard: guards_1.AdminAuthGuard,
    AdminPermissionGuard: permission_guard_1.AdminPermissionGuard,
    PublicGuard: piblic_guard_1.PublicGuard,
    AuthGuard: exports.AuthGuard
};
