"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AdminPermissionGuard = void 0;
const common_1 = require("@nestjs/common");
const user_1 = require("../user");
const core_1 = require("@nestjs/core");
let AdminPermissionGuard = class AdminPermissionGuard {
    constructor(moduleRef, reflector) {
        this.moduleRef = moduleRef;
        this.reflector = reflector;
    }
    onModuleInit() {
        return __awaiter(this, void 0, void 0, function* () {
            this.adminUserService = yield this.moduleRef.get(user_1.AdminUserService);
        });
    }
    canActivate(context) {
        return __awaiter(this, void 0, void 0, function* () {
            const isPublic = this.reflector.get('public', context.getHandler());
            if (isPublic) {
                return true;
            }
            const req = context.switchToHttp().getRequest();
            //获取权限，如果是超级管理员，直接pass
            try {
                if (req.user.is_super) {
                    return true;
                }
                const permissions = yield this.adminUserService.getUserPermission(req.user.id);
                if (permissions.length == 0) {
                    return false;
                }
                const urls = permissions.reduce((pre, item) => {
                    pre[item.uri] = item.method;
                    return pre;
                }, {});
                return urls[req.route.path] == Object.keys(req.route.methods)[0];
                //获取所有的权限，判断url是否在里面，如果没有则没有权限访问
            }
            catch (e) {
                console.log(e);
                return false;
            }
        });
    }
};
AdminPermissionGuard = __decorate([
    (0, common_1.Injectable)(),
    __metadata("design:paramtypes", [core_1.ModuleRef, core_1.Reflector])
], AdminPermissionGuard);
exports.AdminPermissionGuard = AdminPermissionGuard;
