"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateSha1 = exports.randomString2 = exports.randomString = exports.generateHash = exports.UserAuthCache = void 0;
const crypto = require("crypto");
class UserAuthCache {
    constructor(options) {
        this.cacheList = {};
        this.options = options;
    }
    get(key) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                return this.cacheList[key];
            }
            catch (e) {
                throw e;
            }
        });
    }
    getAll() {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                return this.cacheList;
            }
            catch (e) {
                throw e;
            }
        });
    }
    set(key, value) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                this.cacheList[key] = value;
                return key;
            }
            catch (e) {
                throw e;
            }
        });
    }
    remove(key) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                delete this.cacheList[key];
                return true;
            }
            catch (e) {
                this.cacheList[key] = null;
                throw e;
            }
        });
    }
}
exports.UserAuthCache = UserAuthCache;
const generateHash = (len = 10) => {
    return (0, exports.generateSha1)((0, exports.randomString)(len));
};
exports.generateHash = generateHash;
const randomString = (len = 10) => {
    return Math.random().toString(32).substr(2, len) + (0, exports.randomString2)();
};
exports.randomString = randomString;
const randomString2 = (len = 6, charSet) => {
    const chars = charSet || 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
    let randomStr = '';
    for (let i = 0; i < len; i++) {
        randomStr += chars.charAt(Math.floor(Math.random() * chars.length));
    }
    return randomStr;
};
exports.randomString2 = randomString2;
const generateSha1 = (str) => {
    const sha1 = crypto.createHash('sha1');
    sha1.update(str);
    return sha1.digest('hex');
};
exports.generateSha1 = generateSha1;
