import { DynamicModule } from '@nestjs/common';
import { Param } from './types';
import { AdminUserController, AdminUserService, AdminUserEntity } from './user';
import { AdminRoleController, AdminRoleService, AdminRoleEntity } from './role';
import { AdminUserRoleController, AdminUserRoleService, AdminUserRoleEntity } from './user_role';
import { AdminPermissionController, AdminPermissionService, AdminPermissionEntity } from './permission';
import { AdminRolePermissionController, AdminRolePermissionService, AdminRolePermissionEntity } from './role_permission';
import { AdminRoleMenuController, AdminRoleMenuService, AdminRoleMenuEntity } from './role_menu';
import { AdminMenuController, AdminMenuService, AdminMenuEntity } from './menu';
export declare const getAddProviders: () => {
    Controllers: {
        AdminUserRoleController: typeof AdminUserRoleController;
        AdminUserController: typeof AdminUserController;
        AdminRoleController: typeof AdminRoleController;
        AdminPermissionController: typeof AdminPermissionController;
        AdminRolePermissionController: typeof AdminRolePermissionController;
        AdminMenuController: typeof AdminMenuController;
        AdminRoleMenuController: typeof AdminRoleMenuController;
    };
    Services: {
        AdminUserRoleService: typeof AdminUserRoleService;
        AdminUserService: typeof AdminUserService;
        AdminRoleService: typeof AdminRoleService;
        AdminPermissionService: typeof AdminPermissionService;
        AdminRolePermissionService: typeof AdminRolePermissionService;
        AdminMenuService: typeof AdminMenuService;
        AdminRoleMenuService: typeof AdminRoleMenuService;
    };
    Entities: {
        AdminUserRoleEntity: typeof AdminUserRoleEntity;
        AdminPermissionEntity: typeof AdminPermissionEntity;
        AdminUserEntity: typeof AdminUserEntity;
        AdminRoleEntity: typeof AdminRoleEntity;
        AdminRolePermissionEntity: typeof AdminRolePermissionEntity;
        AdminMenuEntity: typeof AdminMenuEntity;
        AdminRoleMenuEntity: typeof AdminRoleMenuEntity;
    };
};
export declare class AdminModule {
    static forRootAsync(param: Param): DynamicModule;
}
