"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var AdminModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.AdminModule = exports.getAddProviders = void 0;
const common_1 = require("@nestjs/common");
const user_1 = require("./user");
const role_1 = require("./role");
const user_role_1 = require("./user_role");
const permission_1 = require("./permission");
const role_permission_1 = require("./role_permission");
const role_menu_1 = require("./role_menu");
const menu_1 = require("./menu");
const global_var_1 = require("./global.var");
const getAddProviders = () => {
    return {
        Controllers: {
            AdminUserRoleController: user_role_1.AdminUserRoleController,
            AdminUserController: user_1.AdminUserController,
            AdminRoleController: role_1.AdminRoleController,
            AdminPermissionController: permission_1.AdminPermissionController,
            AdminRolePermissionController: role_permission_1.AdminRolePermissionController,
            AdminMenuController: menu_1.AdminMenuController,
            AdminRoleMenuController: role_menu_1.AdminRoleMenuController,
        },
        Services: {
            AdminUserRoleService: user_role_1.AdminUserRoleService,
            AdminUserService: user_1.AdminUserService,
            AdminRoleService: role_1.AdminRoleService,
            AdminPermissionService: permission_1.AdminPermissionService,
            AdminRolePermissionService: role_permission_1.AdminRolePermissionService,
            AdminMenuService: menu_1.AdminMenuService,
            AdminRoleMenuService: role_menu_1.AdminRoleMenuService,
        },
        Entities: {
            AdminUserRoleEntity: user_role_1.AdminUserRoleEntity,
            AdminPermissionEntity: permission_1.AdminPermissionEntity,
            AdminUserEntity: user_1.AdminUserEntity,
            AdminRoleEntity: role_1.AdminRoleEntity,
            AdminRolePermissionEntity: role_permission_1.AdminRolePermissionEntity,
            AdminMenuEntity: menu_1.AdminMenuEntity,
            AdminRoleMenuEntity: role_menu_1.AdminRoleMenuEntity,
        },
    };
};
exports.getAddProviders = getAddProviders;
let AdminModule = AdminModule_1 = class AdminModule {
    static forRootAsync(param) {
        return {
            module: AdminModule_1,
            imports: [...param.imports],
            controllers: [...(param && param.controllers)],
            providers: [...(param && param.providers), {
                    provide: global_var_1.ADMIN_PARAM_TOKEN,
                    useValue: param,
                },
                {
                    provide: global_var_1.ADMIN_PARAM_INIT_TOKEN,
                    useFactory: (...args) => __awaiter(this, void 0, void 0, function* () {
                        yield param.useFactory(...args);
                    }),
                    inject: [...param.inject],
                },],
            exports: [...param === null || param === void 0 ? void 0 : param.providers, ...param === null || param === void 0 ? void 0 : param.imports],
        };
    }
};
AdminModule = AdminModule_1 = __decorate([
    (0, common_1.Global)(),
    (0, common_1.Module)({})
], AdminModule);
exports.AdminModule = AdminModule;
