"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AdminRoleController = void 0;
const common_1 = require("@nestjs/common");
const nestjs_abstract_module_1 = require("nestjs-abstract-module");
const entity_1 = require("./entity");
const service_1 = require("./service");
const dto_1 = require("./dto");
const decorators_1 = require("../decorators");
const CrudController = (0, nestjs_abstract_module_1.WrapController)({
    model: entity_1.AdminRoleEntity,
});
let AdminRoleController = class AdminRoleController extends CrudController {
    constructor(service) {
        super(service);
        this.service = service;
    }
    //设置角色权限
    setRolePermission(role_id, body) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.service.setRolePermission(role_id, body);
        });
    }
    //获取角色权限
    getRolePermission(role_id) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.service.getRolePermission(role_id);
        });
    }
    //设置角色菜单
    setRoleMenu(role_id, body) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.service.setRoleMenu(role_id, body);
        });
    }
    //获取角色菜单权限
    getRoleMenu(role_id) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.service.getRoleMenu(role_id);
        });
    }
};
__decorate([
    (0, common_1.Post)(':role_id/permission'),
    __param(0, (0, common_1.Param)('role_id')),
    __param(1, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, dto_1.SetRolePermissionDto]),
    __metadata("design:returntype", Promise)
], AdminRoleController.prototype, "setRolePermission", null);
__decorate([
    (0, common_1.Get)(':role_id/permission'),
    __param(0, (0, common_1.Param)('role_id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", Promise)
], AdminRoleController.prototype, "getRolePermission", null);
__decorate([
    (0, common_1.Post)(':role_id/menu'),
    __param(0, (0, common_1.Param)('role_id')),
    __param(1, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, dto_1.SetRoleMenuDto]),
    __metadata("design:returntype", Promise)
], AdminRoleController.prototype, "setRoleMenu", null);
__decorate([
    (0, common_1.Get)(':role_id/menu'),
    __param(0, (0, common_1.Param)('role_id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", Promise)
], AdminRoleController.prototype, "getRoleMenu", null);
AdminRoleController = __decorate([
    (0, decorators_1.AuthPermissionGuard)(),
    (0, common_1.Controller)('admin/role'),
    __metadata("design:paramtypes", [service_1.AdminRoleService])
], AdminRoleController);
exports.AdminRoleController = AdminRoleController;
