import { AbstractTypeOrmService } from 'nestjs-abstract-module';
import { Repository } from 'typeorm';
import { AdminRoleEntity } from './entity';
import { AdminRolePermissionEntity } from '../role_permission';
import { SetRoleMenuDto, SetRolePermissionDto } from './dto';
import { AdminRoleMenuEntity } from '../role_menu';
export declare class AdminRoleService extends AbstractTypeOrmService<AdminRoleEntity> {
    readonly repository: Repository<AdminRoleEntity>;
    readonly role_permission_repository: Repository<AdminRolePermissionEntity>;
    readonly role_menu_repository: Repository<AdminRoleMenuEntity>;
    constructor(repository: Repository<AdminRoleEntity>, // entity,
    role_permission_repository: Repository<AdminRolePermissionEntity>, role_menu_repository: Repository<AdminRoleMenuEntity>);
    isExistRole(id: any): Promise<boolean | AdminRoleEntity>;
    setRolePermission(role_id: number, body: SetRolePermissionDto): Promise<boolean>;
    getRolePermission(role_id: number): Promise<any>;
    setRoleMenu(role_id: number, body: SetRoleMenuDto): Promise<boolean>;
    getRoleMenu(role_id: number): Promise<any>;
    updateCacheByPermission(permission: any): Promise<void>;
    updateCacheByMenu(data: any): Promise<void>;
}
