"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AdminRoleService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const nestjs_abstract_module_1 = require("nestjs-abstract-module");
const typeorm_2 = require("typeorm");
const entity_1 = require("./entity");
const role_permission_1 = require("../role_permission");
const role_menu_1 = require("../role_menu");
const global_var_1 = require("../global.var");
let AdminRoleService = class AdminRoleService extends nestjs_abstract_module_1.AbstractTypeOrmService {
    // entity: UserEntity;
    constructor(repository, // entity,
    role_permission_repository, role_menu_repository) {
        super(repository, entity_1.AdminRoleEntity);
        this.repository = repository;
        this.role_permission_repository = role_permission_repository;
        this.role_menu_repository = role_menu_repository;
        this.options = Object.assign(Object.assign(Object.assign({}, this.options), { deleteAfterAction: 'normal' }));
        global_var_1.myEmitterInstalled.on('permission_update', (data) => {
            this.updateCacheByPermission(data);
        });
        global_var_1.myEmitterInstalled.on('menu_update', (data) => {
            this.updateCacheByMenu(data);
        });
    }
    isExistRole(id) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.findOne(id);
        });
    }
    setRolePermission(role_id, body) {
        return __awaiter(this, void 0, void 0, function* () {
            const user = yield this.isExistRole(role_id);
            if (user) {
                //删除所有的permission,然后添加
                yield this.role_permission_repository.delete({ role_id });
                global_var_1.AdminStore.setCaches(`role_permission_${role_id}`, null);
                const data = body.permission_ids.map((item) => ({
                    role_id: role_id,
                    permission_id: item,
                }));
                const entityData = this.role_permission_repository.create(data);
                const resultData = yield this.role_permission_repository.save(entityData);
                if (!resultData) {
                    throw new common_1.BadRequestException('插入失败');
                }
                //获取设置的权限，
                const result = yield this.getRolePermission(role_id);
                if (result) {
                    global_var_1.AdminStore.setCaches(`role_permission_${role_id}`, result ? JSON.stringify(result) : undefined);
                }
                return true;
            }
            return false;
        });
    }
    getRolePermission(role_id) {
        return __awaiter(this, void 0, void 0, function* () {
            if (global_var_1.AdminStore.getCaches(`role_permission_${role_id}`)) {
                return JSON.parse(global_var_1.AdminStore.getCaches(`role_permission_${role_id}`));
            }
            const builder = this.role_permission_repository.createQueryBuilder('role_permission');
            builder.leftJoin('admin_permission', 'permission', 'role_permission.permission_id = permission.id');
            builder.leftJoin('admin_role', 'role', 'role_permission.role_id = role.id');
            builder.select(['permission.*']);
            builder.where({
                role_id,
            });
            builder.andWhere('permission.id > 0');
            const result = yield builder.getRawMany();
            if (result) {
                global_var_1.AdminStore.setCaches(`role_permission_${role_id}`, JSON.stringify(result));
            }
            return result;
        });
    }
    setRoleMenu(role_id, body) {
        return __awaiter(this, void 0, void 0, function* () {
            const user = yield this.isExistRole(role_id);
            if (user) {
                //删除所有的menu,然后添加
                yield this.role_menu_repository.delete({ role_id });
                global_var_1.AdminStore.setCaches(`role_menu_${role_id}`, null);
                const data = body.menu_ids.map((item) => ({
                    role_id: role_id,
                    menu_id: item,
                }));
                const entityData = this.role_menu_repository.create(data);
                const resultData = yield this.role_menu_repository.insert(entityData);
                if (!resultData) {
                    throw new common_1.BadRequestException('插入失败');
                }
                yield this.getRoleMenu(role_id);
                return true;
            }
            return false;
        });
    }
    getRoleMenu(role_id) {
        return __awaiter(this, void 0, void 0, function* () {
            if (global_var_1.AdminStore.getCaches(`role_menu_${role_id}`)) {
                return JSON.parse(global_var_1.AdminStore.getCaches(`role_menu_${role_id}`));
            }
            const builder = this.role_menu_repository.createQueryBuilder('role_menu');
            builder.leftJoin('admin_menu', 'menu', 'role_menu.menu_id = menu.id');
            builder.select(['menu.*']);
            builder.where({
                role_id,
            });
            builder.andWhere('menu.id > 0');
            const result = yield builder.getRawMany();
            if (result) {
                global_var_1.AdminStore.setCaches(`role_menu_${role_id}`, JSON.stringify(result));
            }
            return result;
        });
    }
    updateCacheByPermission(permission) {
        return __awaiter(this, void 0, void 0, function* () {
            //通过权限id找到所有的role_id,
            // 然后使用找到所有的role_id，拿出来字符串，找到信息，替换，不用经过sql。
            const builder = this.role_permission_repository.createQueryBuilder('role_permission');
            builder.where({
                permission_id: permission.id,
            });
            const result = yield builder.getMany();
            if (result) {
                const ids = result.map((item) => item.role_id);
                const filter = new Set([...ids]);
                filter.forEach((item) => {
                    const caches = global_var_1.AdminStore.getCaches(`role_permission_${item}`);
                    if (caches) {
                        const to_object = JSON.parse(caches);
                        const findIndex = to_object.findIndex((item) => item.id == permission.id);
                        const copyValue = to_object[findIndex];
                        to_object[findIndex] = Object.assign({}, copyValue, permission);
                        global_var_1.AdminStore.setCaches(`role_permission_${item}`, JSON.stringify(to_object));
                    }
                });
            }
        });
    }
    updateCacheByMenu(data) {
        return __awaiter(this, void 0, void 0, function* () {
            console.log('updateCacheByMenu', data);
        });
    }
};
AdminRoleService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(entity_1.AdminRoleEntity)),
    __param(1, (0, typeorm_1.InjectRepository)(role_permission_1.AdminRolePermissionEntity)),
    __param(2, (0, typeorm_1.InjectRepository)(role_menu_1.AdminRoleMenuEntity)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        typeorm_2.Repository,
        typeorm_2.Repository])
], AdminRoleService);
exports.AdminRoleService = AdminRoleService;
