import { AdminUserEntity } from './entity';
import { AdminUserService } from './service';
import { LoginByEmailDto, LoginByUserNameDto, RegisterByEmailDto, RegisterByUserNameDto, SetUserRoleDto } from './dto';
import { Request, Response } from 'express';
declare const CrudController: new (...args: any[]) => {
    readonly _service: import("nestjs-abstract-module").AbstractTypeOrmService<unknown>;
    findAll: (query: import("nestjs-abstract-module").FindAllQuery) => Promise<{
        data: {
            list: unknown[];
        } | import("nestjs-abstract-module").IpaginationResult<unknown>;
    }>;
    findOne: (id: number) => Promise<{
        data: unknown;
    }>;
    create: (body: any) => Promise<{
        data: any;
    }>;
    update: (id: number, body: any) => Promise<{
        data: unknown;
    }>;
    delete: (id: number) => Promise<boolean>;
};
export interface AdminUserControllerImplements {
    loginByUsername: (body: any, ...args: any[]) => any;
    registerByUserName: (body: any, ...args: any[]) => any;
}
export declare class AdminUserController extends CrudController implements AdminUserControllerImplements {
    readonly service: AdminUserService;
    constructor(service: AdminUserService);
    loginByEmail(body: LoginByEmailDto): Promise<AdminUserEntity | LoginByEmailDto>;
    registerByEmail(body: RegisterByEmailDto): Promise<boolean>;
    loginByUsername(body: LoginByUserNameDto, req: Request, res: Response): Promise<string>;
    logout(req: any): Promise<boolean>;
    registerAdminUser(body: RegisterByUserNameDto, req: Request, res: Response): Promise<AdminUserEntity | "超级管理员已存在">;
    registerByUserName(body: RegisterByUserNameDto, req: Request, res: Response): Promise<AdminUserEntity>;
    getCaptcha(req: Request, res: Response): Promise<string>;
    setUserRole(user_id: number, body: SetUserRoleDto): Promise<boolean>;
    getUserRole(user_id: number): Promise<import("../user_role").AdminUserRoleEntity[]>;
    getUserPermission(user_id: number): Promise<import("../permission").AdminPermissionEntity[]>;
    getUserMenu(user_id: number): Promise<any[]>;
}
export {};
