"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var _a, _b, _c, _d, _e, _f, _g, _h;
Object.defineProperty(exports, "__esModule", { value: true });
exports.AdminUserController = void 0;
const common_1 = require("@nestjs/common");
const nestjs_abstract_module_1 = require("nestjs-abstract-module");
const entity_1 = require("./entity");
const service_1 = require("./service");
const dto_1 = require("./dto");
const express_1 = require("express");
const decorators_1 = require("../decorators");
const CrudController = (0, nestjs_abstract_module_1.WrapController)({
    model: entity_1.AdminUserEntity,
});
let AdminUserController = class AdminUserController extends CrudController {
    constructor(service) {
        super(service);
        this.service = service;
    }
    loginByEmail(body) {
        return this.service.loginByEmail(body);
    }
    registerByEmail(body) {
        return this.service.registerByEmail(body);
    }
    loginByUsername(body, req, res) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.service.checkCode(body.code, req);
            const user = yield this.service.loginByUsername(body);
            const token = yield this.service.generateAuthToken(user);
            yield this.service.deleteCaptcha(res);
            return token;
        });
    }
    logout(req) {
        return __awaiter(this, void 0, void 0, function* () {
            if (req.user == undefined) {
                throw new common_1.ForbiddenException();
            }
            return this.service.logout(req);
        });
    }
    registerAdminUser(body, req, res) {
        return __awaiter(this, void 0, void 0, function* () {
            //创建管理员
            const user = yield this.service.find();
            if (user == undefined || user.list.length == 0) {
                yield this.service.checkCode(body.code, req);
                yield this.service.deleteCaptcha(res);
                return this.service.registerByUserName(Object.assign({}, body));
            }
            return '超级管理员已存在';
        });
    }
    registerByUserName(body, req, res) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.service.checkCode(body.code, req);
            yield this.service.deleteCaptcha(res);
            return this.service.registerByUserName(body);
        });
    }
    getCaptcha(req, res) {
        return __awaiter(this, void 0, void 0, function* () {
            const captcha = yield this.service.getCaptcha();
            res.cookie('captcha', captcha.text);
            return captcha.data;
        });
    }
    //设置用户角色
    setUserRole(user_id, body) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.service.setUserRole(user_id, body);
        });
    }
    getUserRole(user_id) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.service.getUserRole(user_id);
        });
    }
    //获取用户权限
    getUserPermission(user_id) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.service.getUserPermission(user_id);
        });
    }
    //获取用户菜单
    getUserMenu(user_id) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.service.getUserMenu(user_id);
        });
    }
};
__decorate([
    (0, common_1.Post)('loginByEmail'),
    __param(0, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [dto_1.LoginByEmailDto]),
    __metadata("design:returntype", void 0)
], AdminUserController.prototype, "loginByEmail", null);
__decorate([
    (0, common_1.Post)('registerByEmail'),
    __param(0, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [dto_1.RegisterByEmailDto]),
    __metadata("design:returntype", void 0)
], AdminUserController.prototype, "registerByEmail", null);
__decorate([
    (0, common_1.Post)('loginByUserName'),
    (0, decorators_1.PublicDecorator)(),
    __param(0, (0, common_1.Body)()),
    __param(1, (0, common_1.Req)()),
    __param(2, (0, common_1.Res)({
        passthrough: true,
    })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [dto_1.LoginByUserNameDto, typeof (_a = typeof express_1.Request !== "undefined" && express_1.Request) === "function" ? _a : Object, typeof (_b = typeof express_1.Response !== "undefined" && express_1.Response) === "function" ? _b : Object]),
    __metadata("design:returntype", Promise)
], AdminUserController.prototype, "loginByUsername", null);
__decorate([
    (0, decorators_1.AuthGuard)(),
    (0, common_1.Post)('logout'),
    __param(0, (0, common_1.Req)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], AdminUserController.prototype, "logout", null);
__decorate([
    (0, common_1.Post)('registerAdminUser'),
    (0, decorators_1.PublicDecorator)(),
    __param(0, (0, common_1.Body)()),
    __param(1, (0, common_1.Req)()),
    __param(2, (0, common_1.Res)({
        passthrough: true,
    })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [dto_1.RegisterByUserNameDto, typeof (_c = typeof express_1.Request !== "undefined" && express_1.Request) === "function" ? _c : Object, typeof (_d = typeof express_1.Response !== "undefined" && express_1.Response) === "function" ? _d : Object]),
    __metadata("design:returntype", Promise)
], AdminUserController.prototype, "registerAdminUser", null);
__decorate([
    (0, common_1.Post)('registerByUserName'),
    __param(0, (0, common_1.Body)()),
    __param(1, (0, common_1.Req)()),
    __param(2, (0, common_1.Res)({
        passthrough: true,
    })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [dto_1.RegisterByUserNameDto, typeof (_e = typeof express_1.Request !== "undefined" && express_1.Request) === "function" ? _e : Object, typeof (_f = typeof express_1.Response !== "undefined" && express_1.Response) === "function" ? _f : Object]),
    __metadata("design:returntype", Promise)
], AdminUserController.prototype, "registerByUserName", null);
__decorate([
    (0, common_1.Get)('getCaptcha'),
    (0, decorators_1.PublicDecorator)(),
    __param(0, (0, common_1.Req)()),
    __param(1, (0, common_1.Res)({ passthrough: true })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [typeof (_g = typeof express_1.Request !== "undefined" && express_1.Request) === "function" ? _g : Object, typeof (_h = typeof express_1.Response !== "undefined" && express_1.Response) === "function" ? _h : Object]),
    __metadata("design:returntype", Promise)
], AdminUserController.prototype, "getCaptcha", null);
__decorate([
    (0, decorators_1.AuthPermissionGuard)(),
    (0, common_1.Post)(':user_id/role'),
    __param(0, (0, common_1.Param)('user_id')),
    __param(1, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, dto_1.SetUserRoleDto]),
    __metadata("design:returntype", Promise)
], AdminUserController.prototype, "setUserRole", null);
__decorate([
    (0, decorators_1.AuthPermissionGuard)(),
    (0, common_1.Get)(':user_id/role'),
    __param(0, (0, common_1.Param)('user_id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", Promise)
], AdminUserController.prototype, "getUserRole", null);
__decorate([
    (0, decorators_1.AuthPermissionGuard)(),
    (0, common_1.Get)(':user_id/permission'),
    __param(0, (0, common_1.Param)('user_id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", Promise)
], AdminUserController.prototype, "getUserPermission", null);
__decorate([
    (0, decorators_1.AuthPermissionGuard)(),
    (0, common_1.Get)(':user_id/menu'),
    __param(0, (0, common_1.Param)('user_id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", Promise)
], AdminUserController.prototype, "getUserMenu", null);
AdminUserController = __decorate([
    (0, common_1.Controller)('admin/user'),
    __metadata("design:paramtypes", [service_1.AdminUserService])
], AdminUserController);
exports.AdminUserController = AdminUserController;
