"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AdminUserEntity = exports.TransformerPassword = exports.isMatchPassword = exports.hash = void 0;
const typeorm_1 = require("typeorm");
const bcrypt = require("bcrypt");
const nestjs_abstract_module_1 = require("nestjs-abstract-module");
const class_validator_1 = require("class-validator");
const saltOrRounds = 10;
const hash = (password) => {
    console.log(password);
    return bcrypt.hashSync(password, saltOrRounds);
};
exports.hash = hash;
const isMatchPassword = (password, hash) => {
    return bcrypt.compareSync(password, hash);
};
exports.isMatchPassword = isMatchPassword;
class TransformerPassword {
    from(val) {
        return val;
    }
    to(val) {
        return (0, exports.hash)(val);
    }
}
exports.TransformerPassword = TransformerPassword;
let AdminUserEntity = class AdminUserEntity extends nestjs_abstract_module_1.AbstractTypeEntity {
};
__decorate([
    (0, typeorm_1.Column)({
        default: '',
    }),
    __metadata("design:type", String)
], AdminUserEntity.prototype, "mobile", void 0);
__decorate([
    (0, class_validator_1.IsNotEmpty)(),
    (0, class_validator_1.IsEmail)(),
    (0, typeorm_1.Column)({
        default: '',
    }),
    __metadata("design:type", String)
], AdminUserEntity.prototype, "email", void 0);
__decorate([
    (0, class_validator_1.IsNotEmpty)(),
    (0, typeorm_1.Column)({
        default: '',
        transformer: new TransformerPassword(),
    }),
    __metadata("design:type", String)
], AdminUserEntity.prototype, "password", void 0);
__decorate([
    (0, typeorm_1.Column)({
        default: false,
    }),
    __metadata("design:type", Boolean)
], AdminUserEntity.prototype, "is_super", void 0);
AdminUserEntity = __decorate([
    (0, typeorm_1.Entity)('admin_user', {
        synchronize: false
    })
], AdminUserEntity);
exports.AdminUserEntity = AdminUserEntity;
