import { AbstractTypeOrmService } from 'nestjs-abstract-module';
import { Repository } from 'typeorm';
import { AdminUserEntity } from './entity';
import { LoginByEmailDto, LoginByUserNameDto, RegisterByEmailDto, RegisterByUserNameDto } from './dto';
import * as svgCaptcha from 'svg-captcha';
import { Request, Response } from 'express';
import { AdminUserRoleEntity } from '../user_role';
import { AdminPermissionEntity } from '../permission';
export declare class AdminUserService extends AbstractTypeOrmService<AdminUserEntity> {
    readonly repository: Repository<AdminUserEntity>;
    readonly user_role_repository: Repository<AdminUserRoleEntity>;
    readonly permission_repository: Repository<AdminPermissionEntity>;
    constructor(repository: Repository<AdminUserEntity>, // entity,
    user_role_repository: Repository<AdminUserRoleEntity>, permission_repository: Repository<AdminPermissionEntity>);
    __loginByEmail(body: LoginByEmailDto): Promise<AdminUserEntity | LoginByEmailDto>;
    loginByEmail(body: LoginByEmailDto): Promise<AdminUserEntity | LoginByEmailDto>;
    __registerByEmail(body: LoginByEmailDto): Promise<boolean>;
    registerByEmail(body: RegisterByEmailDto): Promise<boolean>;
    loginByUsername(body: LoginByUserNameDto): Promise<AdminUserEntity>;
    __loginByUsername(body: LoginByUserNameDto): Promise<AdminUserEntity>;
    registerByUserName(body: RegisterByUserNameDto): Promise<AdminUserEntity>;
    __registerByUserName(body: RegisterByUserNameDto): Promise<AdminUserEntity>;
    getCaptcha(): Promise<svgCaptcha.CaptchaObj>;
    validateCaptcha(code: string, hash: string): Promise<boolean>;
    checkCode(code: string, req: Request): Promise<void>;
    deleteCaptcha(res: Response): Promise<void>;
    isExistUser(id: any): Promise<boolean | AdminUserEntity>;
    setUserRole(user_id: number, body: any): Promise<boolean>;
    getUserRole(user_id: number): Promise<AdminUserRoleEntity[]>;
    getUserPermission(user_id: number): Promise<AdminPermissionEntity[]>;
    getUserMenu(user_id: number): Promise<any[]>;
    logout(req: Request): Promise<boolean>;
    generateAuthToken(data: any): Promise<string>;
    verifyAuthToken(token: any): Promise<any>;
}
