"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AdminUserService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const nestjs_abstract_module_1 = require("nestjs-abstract-module");
const typeorm_2 = require("typeorm");
const entity_1 = require("./entity");
const class_validator_1 = require("class-validator");
const svgCaptcha = require("svg-captcha");
const bcrypt = require("bcrypt");
const querystring_1 = require("querystring");
const global_var_1 = require("../global.var");
const user_role_1 = require("../user_role");
const permission_1 = require("../permission");
const helper_1 = require("../helper");
let AdminUserService = class AdminUserService extends nestjs_abstract_module_1.AbstractTypeOrmService {
    // entity: UserEntity;
    constructor(repository, // entity,
    user_role_repository, permission_repository) {
        super(repository, entity_1.AdminUserEntity, {
            deleteAfterAction: 'log_sql',
        });
        this.repository = repository;
        this.user_role_repository = user_role_repository;
        this.permission_repository = permission_repository;
        console.log('installer........');
    }
    __loginByEmail(body) {
        return __awaiter(this, void 0, void 0, function* () {
            //判断邮箱是否存在
            //判断是邮箱还是手机
            const builder = this.queryBuilder();
            yield this.addDeleteCondition(builder);
            builder.andWhere({
                email: body.email,
            });
            const user = yield builder.getOne();
            if (user === undefined) {
                throw new common_1.BadRequestException('用户名或密码错误');
            }
            if (!(0, entity_1.isMatchPassword)(body.password, user.password)) {
                throw new common_1.BadRequestException('用户名或密码错误');
            }
            delete user.password;
            return user;
            //判断密码
            //返回用户id
            //前端保存
            return body;
        });
    }
    loginByEmail(body) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.__loginByEmail(body);
        });
    }
    __registerByEmail(body) {
        return __awaiter(this, void 0, void 0, function* () {
            //判断邮箱是否存在
            const builder = this.queryBuilder();
            builder.andWhere({
                email: body.email,
            });
            const user = yield builder.getOne();
            if (user) {
                throw new common_1.BadRequestException('用户已存在');
            }
            const result = (yield this.create(body));
            if (result) {
                return true;
            }
            return false;
        });
    }
    registerByEmail(body) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.__registerByEmail(body);
        });
    }
    loginByUsername(body) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.__loginByUsername(body);
        });
    }
    __loginByUsername(body) {
        return __awaiter(this, void 0, void 0, function* () {
            const builder = this.queryBuilder();
            yield this.addDeleteCondition(builder);
            if ((0, class_validator_1.isEmail)(body.username)) {
                builder.andWhere({ email: body.username });
            }
            else {
                builder.andWhere({ mobile: body.username });
            }
            const user = yield builder.getOne();
            if (user === undefined) {
                throw new common_1.BadRequestException('用户名或密码错误');
            }
            if (!(0, entity_1.isMatchPassword)(body.password, user.password)) {
                throw new common_1.BadRequestException('用户名或密码错误');
            }
            delete user.password;
            return user;
        });
    }
    registerByUserName(body) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.__registerByUserName(body);
        });
    }
    __registerByUserName(body) {
        return __awaiter(this, void 0, void 0, function* () {
            const builder = this.queryBuilder();
            yield this.addDeleteCondition(builder);
            if ((0, class_validator_1.isEmail)(body.username)) {
                builder.andWhere({ email: body.username });
                body.email = body.username;
            }
            else {
                builder.andWhere({ mobile: body.username });
                body.mobile = body.username;
            }
            const user = yield builder.getOne();
            console.log(user);
            if (user) {
                throw new common_1.BadRequestException('用户已存在');
            }
            try {
                const result = (yield this.create(body));
                delete result.password;
                return result;
            }
            catch (error) {
                this.options.logger(error);
                throw new common_1.BadRequestException('未知错误');
            }
        });
    }
    getCaptcha() {
        return __awaiter(this, void 0, void 0, function* () {
            const captcha = svgCaptcha.create({
                // 翻转颜色
                inverse: false,
                // 字体大小
                fontSize: 36,
                // 噪声线条数
                noise: 2,
                // 宽度
                width: 120,
                // 高度
                height: 40,
            });
            captcha.text = bcrypt.hashSync(captcha.text.toLocaleLowerCase(), 8);
            // console.log(
            //   jwt.verify(
            //     'eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJpZCI6NywiY3RpbWUiOjE2MzEyOTEwMzcsIm10aW1lIjoxNjMxMjkxMDM3LCJkdGltZSI6MCwibW9iaWxlIjoiMTU5MjAxMTI4NjEiLCJlbWFpbCI6IjQyNDEyMjIzOTc3MjI3QHFxLmNvbSIsImlhdCI6MTYzMTc1MjQzNX0.jnKy6qyahqYivWYcIlkbd05xzm_jCeIUFOWoSLdw9kc',
            //     JwtOptions.getOptions().secret,
            //   ),
            // );
            return captcha;
        });
    }
    validateCaptcha(code, hash) {
        return __awaiter(this, void 0, void 0, function* () {
            const flag = yield bcrypt.compare(code.toLocaleLowerCase(), hash || '');
            return flag;
        });
    }
    checkCode(code, req) {
        return __awaiter(this, void 0, void 0, function* () {
            const cookies = (0, querystring_1.parse)(req.headers.cookie);
            const captcha = cookies === null || cookies === void 0 ? void 0 : cookies.captcha;
            if (captcha == undefined) {
                throw new common_1.BadRequestException('请获取验证码');
            }
            // if (!captchaList[captcha as string]) {
            //   throw new BadRequestException('验证码不存在');
            // }
            if (!(yield this.validateCaptcha(code, captcha))) {
                throw new common_1.BadRequestException('验证码错误');
            }
            // delete captchaList[captcha as string];
        });
    }
    deleteCaptcha(res) {
        return __awaiter(this, void 0, void 0, function* () {
            res.cookie('captcha', '', { maxAge: 0 });
        });
    }
    isExistUser(id) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.findOne(id);
        });
    }
    setUserRole(user_id, body) {
        return __awaiter(this, void 0, void 0, function* () {
            const user = yield this.isExistUser(user_id);
            if (user) {
                //删除所有的role,然后添加
                yield this.user_role_repository.delete({ user_id: user_id });
                const data = body.role_ids.map((item) => ({
                    user_id: user_id,
                    role_id: item,
                }));
                const entityData = this.user_role_repository.create(data);
                const resultData = yield this.user_role_repository.insert(entityData);
                if (!resultData) {
                    throw new common_1.BadRequestException('插入失败');
                }
                return true;
            }
            return false;
        });
    }
    getUserRole(user_id) {
        return __awaiter(this, void 0, void 0, function* () {
            const builder = this.user_role_repository.createQueryBuilder('user_role');
            builder.leftJoin(
            // 'user_role.role',
            'admin_role', 'role', 'user_role.role_id = role.id');
            // builder.select('role.name', 'user_role.name');
            // builder.select(['user_role', 'role.name']);
            builder.select('role.*');
            builder.groupBy('id');
            builder.where({
                user_id,
            });
            builder.andWhere('role.id > 0');
            const result = yield builder.getRawMany();
            return result;
        });
    }
    getUserPermission(user_id) {
        return __awaiter(this, void 0, void 0, function* () {
            const user = yield this.isExistUser(user_id);
            if (user) {
                const builder = this.user_role_repository.createQueryBuilder('user_role');
                builder.leftJoin('admin_role_permission', 'role_permission', 'role_permission.role_id = user_role.role_id');
                builder.leftJoin('admin_permission', 'permission', 'permission.id = role_permission.permission_id');
                const field = [];
                Object.values(this.permission_repository.metadata.propertiesMap).forEach((item) => {
                    field.push(`permission.${item} as ${item}`);
                });
                builder.select([...field]);
                builder.where({
                    user_id,
                });
                builder.andWhere('permission.id > 0');
                builder.groupBy('id');
                const result = (yield builder.getRawMany());
                return result;
            }
            return [];
        });
    }
    getUserMenu(user_id) {
        return __awaiter(this, void 0, void 0, function* () {
            const user = yield this.isExistUser(user_id);
            if (user) {
                const builder = this.user_role_repository.createQueryBuilder('user_role');
                builder.leftJoin('admin_role_menu', 'role_menu', 'role_menu.role_id = user_role.role_id');
                builder.leftJoin('admin_menu', 'menu', 'menu.id = role_menu.menu_id');
                const field = [];
                builder.select(['menu.*']);
                builder.where({
                    user_id,
                });
                builder.andWhere('menu.id is not null');
                builder.groupBy('id');
                const result = yield builder.getRawMany();
                return result;
            }
            return [];
        });
    }
    logout(req) {
        return __awaiter(this, void 0, void 0, function* () {
            const auth_token = req.headers['auth-token'];
            if (auth_token) {
                if (yield global_var_1.Store.userStore.remove(auth_token)) {
                    return true;
                }
            }
            else {
                return false;
            }
        });
    }
    generateAuthToken(data) {
        return __awaiter(this, void 0, void 0, function* () {
            const payload = Object.assign({}, data);
            const token = yield global_var_1.Store.userStore.set((0, helper_1.generateHash)(), JSON.stringify({
                id: payload.id,
            }));
            return token;
        });
    }
    verifyAuthToken(token) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const value = (yield global_var_1.Store.userStore.get(token));
                return JSON.parse(value);
            }
            catch (e) {
                throw e;
            }
        });
    }
};
AdminUserService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(entity_1.AdminUserEntity)),
    __param(1, (0, typeorm_1.InjectRepository)(user_role_1.AdminUserRoleEntity)),
    __param(2, (0, typeorm_1.InjectRepository)(permission_1.AdminPermissionEntity)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        typeorm_2.Repository,
        typeorm_2.Repository])
], AdminUserService);
exports.AdminUserService = AdminUserService;
